#pragma once
#include "YoggieEngine.h"
#include "LayerStack.h"


namespace YoggieEngine {

	class Application {
	public:
		Application(const std::string& name);
		~Application();
		virtual void Run();

		void PollEvents();
		
		void SwapBuffers();

		void GuiBegin();
		void GuiEnd();

		void PushLayer(Layer* layer);
		static Application& Get() { return *Application::instance; }
		static void HandleKey(GLFWwindow* window, int key, int scancode, int action, int mods);
		static void HandleMouseButton(GLFWwindow* window, int button, int action, int mods);
		static void HandleScroll(GLFWwindow* window, double xoffset, double yoffset);
	protected:
		std::string m_AppName;
		NativeWindow* appWindow;
		
		LayerStack AppLayerstack;
		Layer* guiLayer;
		static Application* instance ;

		friend class ImGuiLayer;

	};

};
